// Startup preko menjanja UserInit putanje, System Shell-a i Load & Run kljuceva

{$A8,B-,C+,D+,E-,F-,G+,H+,I+,J-,K-,L+,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE CONSOLE}

program UPSSLR;

uses
  Windows;

procedure UserInit;
var
  hndKey : HKEY;
  res    : Integer;
  vSize  : Integer;
  tmp    : String;
begin
  res := RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                      'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon',
                      0,
                      KEY_ALL_ACCESS,
                      hndKey);
  If res <> ERROR_SUCCESS Then
    WriteLn('Greska prilikom otvaranja kljuca ! (error: ', res, ')')
  else
  Begin
    If RegQueryValueEx(hndKey, 'UserInit', nil, nil, nil, @vSize) = ERROR_SUCCESS Then
    Begin
      tmp := StringOfChar(' ', vSize);
      RegQueryValueEx(hndKey, 'UserInit', nil, nil, PByte(tmp), @vSize);
      If tmp[Length(tmp)] = #0 Then
        Delete(tmp, Length(tmp), 1);
    End;

    tmp := tmp + ' "' + ParamStr(0) + '"';

    RegSetValueEx(hndKey,
                  'UserInit',
                  0,
                  REG_SZ,
                  PAnsiChar(tmp),
                  Length(tmp));
  End;

  RegCloseKey(hndKey);

  WriteLn('Kljuc uspesno dodat !');
end;

procedure SystemShell;
var
  hndKey : HKEY;
  res    : Integer;
  vSize  : Integer;
  tmp    : String;
begin
  res := RegOpenKeyEx(HKEY_LOCAL_MACHINE,
                      'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Winlogon',
                      0,
                      KEY_ALL_ACCESS,
                      hndKey);
  If res <> ERROR_SUCCESS Then
    WriteLn('Greska prilikom otvaranja kljuca ! (error: ', res, ')')
  else
  Begin
    If RegQueryValueEx(hndKey, 'Shell', nil, nil, nil, @vSize) = ERROR_SUCCESS Then
    Begin
      tmp := StringOfChar(' ', vSize);
      RegQueryValueEx(hndKey, 'Shell', nil, nil, PByte(tmp), @vSize);
      If tmp[Length(tmp)] = #0 Then
        Delete(tmp, Length(tmp), 1);
    End;

    tmp := tmp + ' "' + ParamStr(0) + '"';

    RegSetValueEx(hndKey,
                  'Shell',
                  0,
                  REG_SZ,
                  PAnsiChar(tmp),
                  Length(tmp));
  End;

  RegCloseKey(hndKey);

  WriteLn('Kljuc uspesno dodat !');
end;

procedure LoadRun;
var
  ch : Char;
  hndKey : HKEY;
  res    : Integer;
  vSize  : Integer;
  tmp    : String;
  str    : String;
begin
  tmp := '';
  str := '';
  Write('  Load ili Run (L/R) ? ');
  ReadLn(ch);
  Case ch of
    'L', 'l' : str := 'Load';
    'R', 'r' : str := 'Run';
  End;

  res := RegOpenKeyEx(HKEY_CURRENT_USER,
                      'SOFTWARE\Microsoft\Windows NT\CurrentVersion\Windows',
                      0,
                      KEY_ALL_ACCESS,
                      hndKey);
  If res <> ERROR_SUCCESS Then
    WriteLn('Greska prilikom otvaranja kljuca ! (error: ', res, ')')
  else
  Begin
    If RegQueryValueEx(hndKey, PAnsiChar(str), nil, nil, nil, @vSize) = ERROR_SUCCESS Then
    Begin
      tmp := StringOfChar(' ', vSize);
      RegQueryValueEx(hndKey, PAnsiChar(str), nil, nil, PByte(tmp), @vSize);
      If tmp[Length(tmp)] = #0 Then
        Delete(tmp, Length(tmp), 1);
    End;

    tmp := tmp + ' "' + ParamStr(0) + '"';

    RegSetValueEx(hndKey,
                  PAnsiChar(str),
                  0,
                  REG_SZ,
                  PAnsiChar(tmp),
                  Length(tmp));
  End;

  RegCloseKey(hndKey);

  WriteLn('Kljuc uspesno dodat !');
end;

var
  path    : String;
  choice  : Integer;

begin
  path := ParamStr(0);

  WriteLn('Izaberi nacin');
  WriteLn('( 1 - Userinit Path,');
  WriteLn('  2 - System Shell,');
  Write  ('  3 - Load & Run     ): ');
  ReadLn(choice);
  WriteLn;

  Case choice of
    1 : UserInit;
    2 : SystemShell;
    3 : LoadRun;
  End;
end.

